```
 • ▌ ▄ ·. ▄▄▄▄·     ▄▄▄ .·▄▄▄▄  ▪  ▄▄▄▄▄      ▄▄▄       ▄▄▄·▄▄▄        
 ·██ ▐███▪▐█ ▀█▪    ▀▄.▀·██▪ ██ ██ •██  ▪     ▀▄ █·    ▐█ ▄█▀▄ █·▪     
 ▐█ ▌▐▌▐█·▐█▀▀█▄    ▐▀▀▪▄▐█· ▐█▌▐█· ▐█.▪ ▄█▀▄ ▐▀▀▄      ██▀·▐▀▀▄  ▄█▀▄ 
 ██ ██▌▐█▌██▄▪▐█    ▐█▄▄▌██. ██ ▐█▌ ▐█▌·▐█▌.▐▌▐█•█▌    ▐█▪·•▐█•█▌▐█▌.▐▌
 ▀▀  █▪▀▀▀·▀▀▀▀      ▀▀▀ ▀▀▀▀▀• ▀▀▀ ▀▀▀  ▀█▄▀▪.▀  ▀    .▀   .▀  ▀ ▀█▄▀▪
               Magicbane Emulator Project © 2013 - 2022
                          www.magicbane.com
```

# mbEditorPro v 2.1

![Example JSON](https://cdn.discordapp.com/attachments/399623779531096074/1029063849640468550/unknown.png)<br>
![Example Textures](https://cdn.discordapp.com/attachments/534260038039109632/1056584030310641696/image.png)<br>
![Example Usage](https://cdn.discordapp.com/attachments/398522378545790976/1058787471544025138/image.png)<br>

Team Magicbane presents to the community technology allowing MagicBox administrators<br>
to fully modify their game using nothing more than notepad.exe. <br>

- Tool directly converts Shadowbane .cache file data to and from a high fidelity pure JSON representation.
- Media such as textures and sound are converted in-situ.
- Enumerations are used throughout hiding from the user ugly signed ulong values.
- Written in Python and open-source allowing modification and extension with ease.
- Want to raise all weapon damage by x%; Just modify item values as they are being parsed!

The tool built with Eldritch Technologies parses **all Shadowbane .cache files** giving the user complete control over the game<br>

Team Magicbane aims to deliver you the best crackhead free MMO technology around; all for free!

### Requirements:

mbEditorPro requires pillow for image manipulation and tqdm for metrics.

```$ pip install -r requirements.txt```

### Usage:
```
mbEditorPro.py unpack cobjects
mbEditorPro.py unpack all
```
JSON output will be placed into the folder **ARCANE DUMP** <br>

```
mbEditorPro.py pack textures
mbEditorPro.py pack all
```

New binary cache file(s) will be built from the JSON and output into the current directory. <br>

### Limitations

Hirelings, ZoneEvents and Mobile Inventory are not parsed or written as there were no <br>
examples in the .cache files to begin with.  The game does seem to support them, however.

### JSON

The tool generating pure JSON has the following benefits:

- It's ubiquitous and the tooling is mature.  The standard interop exchange format.
- Human and machine-readable.
- Ease of importing into MySQL or other databases.
- Use as an intermediate representation to build a GUI World Editor or FBX importer.

### Future

mbEditorPro will be the cornerstone of Magicbane's data project. The Team's goals are threefold:

- Ship MagicBox 1.5 with both Aerynth and Vorringia mapsets.
- Integrate Magicbane's wpak extractor technology into the tool.
- Use data for a detailed audit of Magicbane's database.<br>

### More Information

See the mbEditorPro2.0 Wiki for more detailed information.

